import { ref as h, markRaw as S, shallowReactive as M, defineComponent as C, onUnmounted as b, createElementBlock as V, openBlock as p, Fragment as k, renderList as O, unref as R, createBlock as _, resolveDynamicComponent as F } from "vue";
import { waitWhile as q } from "../utils/system.js";
import { historySetState as y, genHash as D, getHash as L } from "../utils/route.js";
import { querySelectorAllArray as B } from "../utils/dom.js";
class c {
  static state = {
    load: void 0,
    decoratorOnCreate: void 0,
    /**
     * Порядковай номер перехода в диалоговых окнах
     *
     * Для расчета анимации Вперед / Назад
     */
    viewPageN: 0
  };
  static inited = !1;
  /**
   * Инициировать события слежения за парамтерами url
   *
   * Если в параметрах есть запрос на открытие диалогового окна, TopDialog будет автоматически подключен на страницу
   */
  static init(e) {
    if (this.inited) return;
    this.inited = !0, this.state.load = e == null ? void 0 : e.load, this.state.decoratorOnCreate = e == null ? void 0 : e.decoratorOnCreate;
    const t = (e == null ? void 0 : e.autoInitDelay) ?? 5e3;
    window.addEventListener("hashchange", (a) => {
      this.opendDialogsFromChangeUrl(a.oldURL, a.newURL);
    }), this.opendDialogsFromChangeUrl("", location.href), document.addEventListener("mousedown", async (a) => {
      const s = a.target.closest("a[data-to-view]");
      if (!s) return;
      let r = "next";
      s.dataset.action === "top-dialog-close" && (r = "prev"), s.href = c.genViewPageHash(s.dataset.toView, r);
    }), document.addEventListener("click", async (a) => {
      var U, x;
      const s = a.target.closest("[data-to-view]");
      if (!s) return;
      if (s instanceof HTMLAnchorElement && s.href === ".") {
        a.preventDefault();
        const g = new MouseEvent("mousedown", {
          bubbles: !0,
          cancelable: !0,
          view: window
        });
        s.dispatchEvent(g), setTimeout(() => s.click());
        return;
      }
      const r = await this.getDialogsUtils(), n = s.dataset.toView, w = n.split("-")[0], l = document.getElementById(w), P = B(l, ".modal-layer"), N = P.reduce((g, A) => {
        const u = A.querySelector(":scope > .active");
        return u && g.push(u), g;
      }, []), H = !!(l != null && l.dataset.toViewReplace);
      let v = "next";
      if (N.length) {
        const g = n.split("-")[1].split(":")[0];
        (((U = P.reduce((u, m) => {
          const E = m == null ? void 0 : m.querySelector(`:scope > [data-view-page="${g}"]`);
          return E && u.push(E), u;
        }, [])[0]) == null ? void 0 : U.dataset.order) ?? 0) < (((x = N[0]) == null ? void 0 : x.dataset.order) ?? 0) && (v = "prev");
      }
      s.dataset.action === "top-dialog-close" && (v = "prev");
      const f = c.genViewPageHash(n, v);
      if (s instanceof HTMLAnchorElement) {
        if (!(l != null && l.checkVisibility())) return;
        if (location.hash.indexOf(n.replace("-", "=")) !== -1) {
          await r.toViewDirty(n);
          return;
        }
      }
      H ? (a.preventDefault(), y(!0, f), await r.toViewDirty(n), v == "next" ? c.state.viewPageN++ : c.state.viewPageN--) : s.tagName !== "A" && (this.compareStates(f, location.hash) ? y(!1, f) : await r.toViewDirty(n));
    }), setTimeout(() => this.getDialogsUtils(), t);
  }
  static opendDialogsFromChangeUrl(e, t) {
    const a = e.replace(/.*?#/, "#"), i = t.replace(/.*?#/, "#");
    this.compareStates(a, i) && this.opendDialogsFromUrl();
  }
  static async getDialogsUtils() {
    const { TopDialogUtils: e } = await import("./utils-BcKnFj1j.es.js");
    return e;
  }
  static getDialog(e) {
    return e.closest("dialog");
  }
  static getPage(e) {
    return e.closest("[data-view-page]");
  }
  /**
   * todo: Переписать на сайте на this.getDialog()
   *
   * @deprecated Для обратной совместимости
   */
  static get$dialog(e) {
    return e.closest(".ui-dialog-content");
  }
  /**
   * todo: Переписать на сайте на this.getPage()
   *
   * @deprecated Для обратной совместимости
   */
  static get$page(e) {
    return e.closest("[data-view-page]");
  }
  /**
   * todo: Переписать на сайте на this.getPairPage()
   *
   * @deprecated Для обратной совместимости
   */
  static get$pairPage(e) {
    const t = c.get$dialog(e), i = c.get$page(e).data("view-page");
    return $('[data-view-page="' + i + '"]', t);
  }
  static getPairPage(e) {
    const t = c.getDialog(e), a = c.getPage(e), i = a == null ? void 0 : a.dataset.viewPage;
    return t == null ? void 0 : t.querySelectorAll(`[data-view-page="${i}"]`);
  }
  /**
   * Закрыть диалоговое окно
   */
  static close(e) {
    const t = $("#" + e);
    t.dialog("instance") && t.dialog("close");
  }
  /**
   * Размонтировать $.dialog
   */
  static destroy(e) {
    const t = $("#" + e);
    t.dialog("instance") && (t.dialog("close"), t.dialog("destroy"));
  }
  /**
   * Сгенерировать ссылку на страницу в диалоговом окне
   * @param toView - указатель в формате: dialog_{{ dialogId }}={{ pageName }}:{{ args }}
   * @param moveDirection
   */
  static genViewPageHash(e, t = "next") {
    let a = this.state.viewPageN;
    t == "prev" ? a-- : a++;
    const i = e.split("-"), s = i.shift(), r = i.join("-");
    let n = D("vpn", a);
    return n = D("view-" + s, r, n), n;
  }
  /**
   * Сравнить версию открытых диалоговых окон
   * @returns вернет true, если состояния открытых окон изменилось
   */
  static compareStates(e, t) {
    const a = e.match(/[#&]view-[^&]+/g) || [], i = t.match(/[#&]view-[^&]+/g) || [];
    return !!(a.length !== i.length || a.filter((r, n) => {
      const w = i[n] || "";
      return r !== w;
    }).length);
  }
  static opendDialogsFromUrl = async () => {
    const e = Number(L("vpn")) || 0;
    let t;
    const a = new RegExp("view-((\\w+)=([\\w-]+)(?::([\\w.:-]+))?)", "g");
    for (; t = a.exec(location.hash); ) {
      let i = "next";
      return e < this.state.viewPageN && (i = "prev"), (await this.getDialogsUtils()).toViewDirty(t[1], i);
    }
    return $(".ui-dialog-content[data-view-page-active]:visible").each((i, s) => {
      const r = $(s), n = r.attr("id");
      L("view-" + n) || r.dialog("close");
    }), this.state.viewPageN = e, !0;
  };
}
class I {
  /**
   * Индентификатор, определяется на уровне компонента TopDialogComponent
   *
   * Может использоваться в навигации для открытия нужных окон с нужными настройками
   */
  id;
  /**
   * ID, используемый в верстке диалогового окна
   */
  idAttr;
  /**
   * Пользовательский компонент диалогового окна
   */
  Component;
  /**
   * Компонент инициирован
   *
   * Устанавливается после первого вызова useTopDialog()
   */
  isMounted = h(!1);
  /**
   * Компонент готов к использованию
   *
   * Используется для внутренних преобразований после отрисовки
   */
  isReady = h(!1);
  /**
   * Диалоговое окно открыто
   */
  isOpened = h(!1);
  /**
   * Имя активной страницы дилогового окна
   */
  pageActive = h("");
  /**
   * Диалоговое окно находится в состоянии загрузки своей страницы
   */
  isLoadingPage = h(!1);
  /**
   * Следующая активная страница
   *
   * В один момент времени может потребоваться отобразить две страницы, чтобы воспроизвести анимацию
   */
  pageActiveNext = h("");
  /**
   * props компонента, доступны после инициализации
   */
  props;
  /**
   * emit базового компонента `TopDialog`
   */
  emit;
  /**
   * Одноразовое событие на закрытие диалогового окна
   *
   * Используется для привязки окна к сценариям использования
   */
  onCloseOnce;
  constructor(e) {
    this.id = e.id, this.idAttr = "dialog_" + e.id, this.Component = S(e);
  }
  /**
   * Событие - компонент инициирован
   */
  onMounted(e, t) {
    this.isMounted.value = !0, this.props = e.props, this.emit = t.emit;
  }
  /**
   * Открыть диалоговое окно
   *
   * Учтите, что props в диалоговом окне будут доступны не сразу, а только после инициализации vue компонента
   */
  async open(e = "main", t, a = [], i, s) {
    t && await this.setProps(t), i && (this.onCloseOnce = i), await (await c.getDialogsUtils()).toView(this.idAttr, e, a, s);
  }
  /**
   * Открыть диалоговое окно как ссылку, для хеш-навигации
   *
   * Диалоговые окна загружаются по имени, см. настройку плагина Core topDialogLoader
   */
  async openAsLink(e = "main", t, a = [], i, s) {
    t && await this.setProps(t), i && (this.onCloseOnce = i);
    const r = this.idAttr + "-" + e, n = c.genViewPageHash(r, s);
    y(!1, n);
  }
  /**
   * Закрыть диалоговое окно
   *
   * Не меняет состояние компонента диалогового окна
   */
  async close() {
    c.close(this.idAttr);
  }
  /**
   * Размонтировать $.dialog
   */
  async destroy() {
    c.destroy(this.idAttr);
  }
  /**
   * Устанвоить props
   *
   * Полностью сбрасывается состояние props
   */
  async setProps(e = {}) {
    this.isMounted || await q(() => !this.props);
    for (const t in this.props)
      this.props[t] = e[t];
  }
  /**
   * Проверить, есть ли необходимость отрисовки страницы диалогового окна
   */
  needShowPage(e) {
    return this.isOpened.value ? this.pageActive.value === e || this.pageActiveNext.value === e : !1;
  }
}
const j = {
  class: "top-dialogs",
  style: { display: "none" }
}, d = M(/* @__PURE__ */ new Map()), Q = (o) => (o = o.replace(/^dialog_/, ""), d.get(o)), X = (o) => {
  if (!(o != null && o.id))
    throw console.log({ TopDialogComponent: o }), new Error("Expected TopDialogComponent");
  return d.has(o.id) || d.set(o.id, new I(o)), d.get(o.id);
}, Y = /* @__PURE__ */ C({
  name: "DialogWrapper",
  __name: "dialogs",
  setup(o) {
    return b(() => {
      d.forEach((e) => e.destroy()), d.clear();
    }), (e, t) => (p(), V("div", j, [
      (p(!0), V(k, null, O(R(d), ([a, i]) => (p(), _(F(i.Component), { key: a }))), 128))
    ]));
  }
});
export {
  c as T,
  Y as _,
  X as a,
  Q as g
};
//# sourceMappingURL=dialogs.vue_vue_type_script_setup_true_lang-X3S_WcSV.es.js.map
