import { Item, Props } from '../types';
import { Ref } from 'vue';
export type API = ReturnType<typeof useAPI>;
export declare const useAPI: (apiRequest: Props["apiRequest"], minLength: number, useCache: Props["useCache"]) => {
    apiRequest: {
        [propName: string]: any;
        params: {
            limit?: number;
            offset?: number;
            search?: string;
        };
        call: Function;
        cache: Map<string, {
            result: Array<Item>;
            nextOffset?: number;
        }>;
    } | undefined;
    items: Ref<{
        [x: string]: any;
        id: number | null;
        name: string;
    }[], Item[] | {
        [x: string]: any;
        id: number | null;
        name: string;
    }[]>;
    isLoading: Ref<boolean, boolean>;
    loadAppend: () => Promise<void>;
    setSearchTextAndLoad: (searchText: string, useDebounce?: boolean) => void;
};
